#PROJECT : VNC 3.3 client and server for Inferno
#AUTHOR :  Marc Hufschmitt, marcas1@mime.univ-paris8.fr

# Several debugging print and common functions

printrect(r : Draw->Rect) : string
{
    return sys->sprint("%d,%d %d,%d [%dx%d]",r.min.x, r.min.y, r.max.x, r.max.y, r.dx(),r.dy());
}

debug(level : int , message : string)
{
    if (DEBUGLEVEL>=level)
	sys->fprint(stderr,"%s\n",message);
}

fatal(l : int)
{

    # lecture du pid du programme
    pid :=sys->pctl(0,nil); 

    # on ouvre le descripteur de control du process pid
    fd := sys->open("/prog/" + string pid + "/ctl", sys->OWRITE);
    # si /prog n'est pas binde sur #p, on y va directement
    if(fd == nil)
	fd = sys->open("#p/" + string pid + "/ctl", sys->OWRITE);
    # on envoie 'killgrp' dans le fichier de controle
    if(fd != nil)
	sys->fprint(fd, "killgrp");    

    if (fd!=nil)
	sys->sleep(2000);
    exit;
}


initdisplay(ctxt : ref Context): ref Context
{
    entrees := array[5] of sys->Dir;
    drofd :=sys->open("#d/draw",sys->OREAD);
    n:=sys->dirread(drofd,entrees);
    if (n<2)
    {
	fatal(sys->fprint(stderr,"Absence de session graphique %d\n",n));
    }


    
    if (ctxt==nil) {
	fatal(sys->fprint(stderr,"Absence de session graphique\n"));
	sys->print("create Context\n");
	ctxt = ref Context;
    }

    if (ctxt.display==nil) {
	fatal(sys->fprint(stderr,"Absence de session graphique\n"));
	
	sys->print("create Display\n");
	ctxt.display = Display.allocate(nil);
	if(ctxt.display == nil) {
	    fatal(sys->fprint(stderr,"VNCsrv: can't initialize display: %r\n"));
	
	}
    }

    if (ctxt.screen==nil) {
	fatal(sys->fprint(stderr,"Absence de session graphique\n"));
	sys->fprint(stderr,"create Screen\n");
        ctxt.screen = Screen.allocate(ctxt.display.image, ctxt.display.rgb(161, 195, 209), 1);
	sys->print("screen ID %d\n",ctxt.screen.id);
	#ctxt.display.image.draw(ctxt.display.image.r, ctxt.screen.fill, ctxt.display.ones, ctxt.display.image.r.min);
	if(ctxt.screen == nil) {
	    fatal(sys->fprint(stderr,"VNCsrv: can't initialize screen: %r\n"));
	}
    }
#    sys->sleep(10000);

    return ctxt;
}

gethostname() : string
{
    hostname : string;
    fd :=sys->open("/dev/sysname",sys->OREAD);
    if (fd==nil) {
	sys->fprint(stderr,"Impossible de lire /dev/sysname\n");
	hostname="unknown";
    } else {
	sysname :=array[50] of byte;
	n :=sys->read(fd,sysname,len sysname);
	hostname= string sysname[0:n];
    }
    return hostname;
}





#      sys->print("create colromap\n");
#      if (okcolor==0) {
#  	colormap= array[1<<(1<<ldepth)] of byte;
#  	for (ic:=0; ic <(1<<(1<<ldepth)); ic++)
#  	{
#  	    (r,g,b):=ctxt.display.cmap2rgb(ic);
#  	    if (ldepth==3) {
#  		colormap[ic]=byte ((b & 2r11000000) | ((g>>2) & 2r00111000) | (r>>5));
#  		#sys->print("%d %d,%d,%d %d,%d,%d\n",ic,r,g,b,(r>>5),((g>>2) & 56),(b & 192));
#  	}
#  	    if (ldepth==4) colormap[ic*2:]= rfb->CARD(16, (int ( b & 240) << 8 ) | (int (g & 252) << 4) | (int (r & 252)>>2));
	    
#  	}
#  	okcolor=1;
#      }
#      sys->print("created colromap\n");

notecmd := array[] of {
    "frame .f",
    "label .f.l -bitmap error -foreground red",
    "button .b -text Continue -command {send cmd done}",
    "focus .f",
    "bind .f <Key-\n> {send cmd done}",
    "pack .f.l .f.m -side left -expand 1 -padx 10 -pady 10",
    "pack .f .b -padx 10 -pady 10",
    "update; cursor -default"
    };

notice(ctxt : ref Draw->Context, message: string)
{
    t := tk->toplevel(ctxt.screen, "-x 70 -y 70 -borderwidth 2 -relief raised");
    cmd := chan of string;
    tk->namechan(t, cmd, "cmd");
    tk->cmd(t, "label .f.m -text {"+message+"}");
    for(i := 0; i < len notecmd; i++)
	tk->cmd(t, notecmd[i]);
    <-cmd;
}

username() : string
{
    buf := array[255] of byte;
    fd := sys->open("/dev/user",sys->OREAD);
    n:=sys->read(fd,buf,len buf);
    fd = nil;
    return string buf[0:n];
}
