#PROJECT : VNC 3.3 client and server for Inferno
#AUTHOR :  Marc Hufschmitt, marcas1@mime.univ-paris8.fr

implement VNCserver;
# modif : 14.06.1999

# serveur VNC pour Inferno
# ########################
# gere le true color (VNC(rfb) (ne gere pas les couleur indexee)
# gere le 8 et 16 bit rgb
# gere Init, Frame update et request, gere souris

DEBUGLEVEL:=0;

include "sys.m";
        sys: Sys;
        stderr: ref Sys->FD;

include "tk.m";
	tk: Tk;

include "sh.m";
     sh : Command;

include "csget.m";
csget : CsGet;

include "wmlib.m";
	wmlib: Wmlib;

include "vncauth.m";
vncauth : VNCauth;

include "draw.m";
 draw: Draw;
Point,  Rect, Screen, Display, Image, Context : import draw;
 contxt: ref Context;

include "rfbproto.m";
rfb : RFBprotocol;
CARD, INT, CARDRECT,Rectangle ,
    Encodages, ServerInitialisation, VersionMsg, ClientInitialisation,PixelFormat : import rfb;

include "VNCinclude.b";
include "VNChextile.b";
include "vncRREcoRRE.b";

#rfbPixelFormat := array[16] of byte;
hostname :string;
port :int;
appname :string;
screenWidth :int;
screenHeight :int;
Crefuseconnect :=0;
Cignoreevent :=0;
Cdisplayauto :=0;
Cvncauth :=0;
passwordfile : string;

passwd : string;
MAXAUTHFAILED : con 3;
MAXCONN : con 5;
VNCstat := array[10] of { * => 0 };
requetes :=0;
#VNCrequests : list of request;
connections : list of ref Sys->Connection;
#VNCcolormode : int;
#VNCbitperpixel : int;
#sz_rfbPixelFormat : con 16;
#sz_rfbServerInitMsg : con (8 + sz_rfbPixelFormat);


#rfbServerInitMsg : array of byte;


VNCserver: module
{
        init: fn (ctxt: ref Draw->Context, argv: list of string);
};

include "VNChttpsrv.b";

net:="/net";
#mchan : chan of (int,int,int);
mfd: ref Sys->FD;
okcolor:=0;

#depth:=16;
ldepth:int;
bigEndianPix:=0;
oldpix:= array[1024*748] of byte;
pix := array[1024*748] of byte;
#oldpix=array[(rd.max.x+rd.min.x)*(rd.max.y-rd.min.y)] of byte;
#pix=array[(rd.max.x+rd.min.x)*(rd.max.y-rd.min.y)] of byte;
Infernocolormap:=array[256] of (int,int,int);

init(ctxt: ref Draw->Context, argv: list of string)
{
    # Chargemnt du module systeme
    sys = load Sys Sys->PATH;
    # en cas d'erreur fin sans message
    if (sys==nil) 
	exit;
    
    # on definit le descripteur de sortie des erreurs
    stderr = sys->fildes(2);
    
    if (ctxt==nil) {
	sys->fprint(stderr,"Le contexte graphique n'a pas ete initialise\n");
	return;
    }
	
    # On cree un nouveau groupe de processus
    sys->pctl(sys->NEWPGRP, nil);
    
    if (sys->bind("#I","/net",sys->MAFTER)<0)
	sys->fprint(stderr,"Impossible de charger le driver reseau\n");

    if ((csget = load CsGet CsGet->PATH) == nil)
	fatal(sys->fprint(stderr,"Impossible d'obtenir les services reseau\n"));
    #csget->init(ctxt,argv);
    

    if ((vncauth = load VNCauth VNCauth->PATH) == nil)
	fatal(sys->fprint(stderr,"module Draw :%r\n"));
    passwordfile = "/usr/"+username()+"/vnc/.VNCpasswd";
    passwd = vncauth->DecryptPasswdFromFile(passwordfile);


    draw = load Draw Draw->PATH;
    if (draw==nil)
	fatal(sys->fprint(stderr,"module Draw :%r\n"));
    
    wmlib = load Wmlib Wmlib->PATH;

    tk = load Tk Tk->PATH;
    if (tk==nil) 
	fatal(sys->fprint(stderr,"module Tk :%r\n"));


    rfb = load RFBprotocol RFBprotocol->PATH;
    if (rfb==nil) {
	sys->fprint(stderr,"module RFBprotocole :%r\n");
	exit;
    }
    
    
    contxt=ctxt;
    for (i:=0; i<256; i++) 
	Infernocolormap[i]=ctxt.display.cmap2rgb(i);

    rfb->init();
    rfb->DEBUG=0;

    # On prend le nom de l'application
    appname = hd argv;
    argv = tl argv;
    
    port = 0;
    # Gestion des arguments
    if (len argv==1) {
	# fixe le port d'apres le premier argument
	port = int hd argv;
	argv = tl argv;
	
    } else {
	sys->print("usage: %s [server-number(0 par defaut)]\n",
		   appname);
    }
    # valeur inferieure a 100, la valeur etait un numero de display
    if (port < 100) port += 5900;
    
    hostname=gethostname();
    
    
    sys->print("%s : server %s\n",appname, hostname);

    ctxt=initdisplay(ctxt);
    screct :Rect;
    (screct,ldepth)=readdisplayproperties(ctxt);
    #sys->print("%d %d %d %d %d\n",screct.min.x,screct.min.y,screct.max.x,screct.max.y,sldepth);
    screenWidth =screct.max.x-screct.min.x;
    screenHeight =screct.max.y-screct.min.y;

    sys->print("Taille du serveur %d x %d [%d couleurs]\n",screenWidth,screenHeight,1<<ldepth);

    #mfd = sys->open("/dev/pointer", sys->OWRITE);	
    #if(mfd == nil) {
    #sys->print("open: /dev/pointer: %r\n");
#	return;
#    }

#    mchan = chan of (int,int,int);
#    spawn mouse(ctxt.screen);
#    spawn sh->init(ctxt, "sh" :: nil);
    
    
    spawn vncconf(ctxt);

    spawn javasrv(5800,screenWidth,screenHeight);
    
    while(1) {
	if (Crefuseconnect==0) {
	    # Wait for an incoming connection
	    if ((c :=EcouteTcp(port)) == nil) {
		sys->sleep(2000);
		continue;
	    }
	    if (Crefuseconnect==0)
	    {
		if ((n:=addconn(c))>=0) {
		    sys->fprint(stderr,"Client %d\n",n);
		    spawn initconn(c, ctxt);
		} 
		else {
		    # quota MAXCONN depasse
		    delconn(c);
		    sys->sleep(500);
		}
	    }
	}
	sys->sleep(50);
    }
}

# elimine les autres connections (client en mode non partage)
killotherconn(c : ref Sys->Connection) : int
{
    count :=0;
    lt : list of ref Sys->Connection;
    while (connections != nil) {
	el := hd connections;
	if (el!=c) {
	    if (el !=nil)
		sys->write(el.cfd,array of byte "hangup",6);
	    count++;
	}
	else
	    lt = el :: nil;
	connections = tl connections;
    }
    connections = lt;
    return count;
}

# Ajoute une connection a la liste
addconn(c : ref Sys->Connection) : int
{
    if (len connections > MAXCONN)
	return -1;
    connections = c :: connections;
    return len connections;
}

# Termine une connection c
# si c est a nil, libere la liste des connections deja terminees
delconn(c : ref Sys->Connection) : int
{
    count := 0;
    lt : list of ref Sys->Connection;
    while (connections != nil) {
	el := hd connections;
	if (el==c) {
	    sys->write(el.cfd,array of byte "hangup",6);
	    count++;
	}
	else
	    lt = el :: nil;
	connections = tl connections;
    }
    connections = lt;
    return count;
}    

initconn(c : ref Sys->Connection,  ctxt : ref Draw->Context)
{
    
    if (c==nil) { 
	fatal(sys->fprint(stderr,"%s: listen failed on port %d (%r)\n",appname,port));
    }
    
    debug(0,appname+": listening on port "+string port);

    #######################################
    # Echange des versions
    #######################################

    # Creation de la version
    pvs :=ref VersionMsg;
    pvs.init();
    # Ecriture Version
    if (rfb->WriteExact(c, pvs.struct, pvs.SIZE)<0) {
	sys->fprint(stderr,"Ecriture Version %r\n"); 
	exit;
    }

    # Creation d'une version
    pvc :=ref VersionMsg;
    pvc.init();
    # Lecture version client
    if (rfb->ReadExact(c, pvc.struct, pvc.SIZE)<0) {
	sys->fprint(stderr,"Lecture Version %r\n"); 
	exit;
    }
    
    # Comparaison des versions
    (dmaj,dmin):=pvs.cmp(pvc);
    sys->print("Difference des versions M%d m%d\n",dmaj,dmin);
    if (dmaj!=0 && dmin!=0)
	fatal(sys->fprint(stderr,"Version du protocole differentes\n"));

    pvs=nil;
    pvc=nil;


    #######################################
    # Connection et authentification
    #######################################

    if (Crefuseconnect != 0 || (len passwd == 0)) {
	if (rfb->Send_ConnectionFailed(c,rfb->ConnectionFailed))
	    return;
	if (len passwd == 0) 
	    notice(ctxt,"Le mot de passe du serveur n'a pas ete fixe");
	rfb->Send_ConnectionFailedReason(c,appname+" refuse toute nouvelle connection VNC\n");
	# Server must close the connection
	c = nil;
	return;
    }
    
    auth : int;
    case Cvncauth {
	0 => auth = rfb->NoAuth;
	1 => auth = rfb->VNCAuth;
    }
    if (rfb->Send_ConnectionFailed(c,auth)<0)
	debug(0,"Ecriture connection mode failed");

    
    
    essai :=0;
    authstat : int;

    if (Cvncauth==1) {
	vncauth->init();
	# genere une cle aleatoire et envoi au client
	challengekey := vncauth->randombuf(vncauth->ReallyRandom,16);
	if (rfb->Send_ChallengeKey(c, challengekey) < 0) {
	    fatal(sys->fprint(stderr,"Ecriture Challenge key %r\n")); 
	}
	# crypte le message
	vncauth->EncryptBytes(challengekey,passwd);
	#sys->print("srv encry %s\n",rfb->hexstrbuf(challengekey));
	if (len (responsekey:=rfb->Receive_ResponseKey(c))!=16) {
	    fatal(sys->fprint(stderr,"Lecture response key %r\n")); 
	}
	# Comparaison des clefs
	if (equarray(responsekey[0:16],challengekey[0:16])) {
	    authstat =  rfb->AuthOK;
	}
	else {
	    authstat =  rfb->Authfailed;
	    if (essai >= MAXAUTHFAILED) {
		authstat = rfb->Authtoomany;
	    }
	    essai++;
	}
	if (rfb->Send_AuthStatus(c, authstat) < 0) {
	    fatal(sys->fprint(stderr,"Ecriture Auth result %r\n")); 
	}	
    }
    
    # On detruit la connection si le serveur ne les accepte pas 
    # ou si le client n'a pas genere la bonne clef avant MAXAUTHFAILED essais
    
    if (Crefuseconnect!=0 || authstat==rfb->Authfailed) {
	if ((n:=delconn(c))<0) 
	    sys->fprint(stderr,"Impossible de retirer la connection\n");
	else {
	    delconn(c);
	    sys->fprint(stderr,"Connection eliminee\n");
	    return;
	}
    }

    #######################################
    # Lecture de l'initialisation client
    #######################################

    # connection partagee ?
    sharedflag : int; 
    cim := ref rfb->ClientInitialisation;
	if ((sharedflag=cim.read(c))<0)
	    return;
	if (sharedflag==0) {
	    sys->fprint(stderr,"connection excusive\n");
	    killotherconn(c);
	}


    #######################################
    # Creation d'un format de pixel
    #######################################
    pixformat := ref rfb->PixelFormat;
    # Le serveur VNC prefere les colormap
    pixformat.set(pixformat.colormap());
    
    # Ecriture de l'init serveur avec format de pixel, taille et nom	
    sim : ref rfb->ServerInitialisation;
    if (sim.write(c,screenWidth,screenHeight,pixformat.PIXEL_FORMAT,hostname)<0)
	return;
    sys->print("init done\n");

    
    sys->print("%s\n",pixformat.sprint());
    gereclient(c,ctxt,pixformat);

    
    if ((n:=delconn(c))<0) {
	sys->fprint(stderr,"Impossible de retirer la connection\n");
    } else {
	sys->print ("Fin de la connection %d\n",n);
    }

}

gereclient(c: ref sys->Connection, ctxt : ref Context, pf : ref rfb->PixelFormat)
{
    #rd :=ctxt.display.image.r;
    #ctxt.display.image.readpixels(rd,oldpix);
    encodagel := ref Encodages;

    for (i:=0; i<len oldpix; i++) oldpix[i]=byte 0;
    
    msg := array[1] of byte;
    n :int;
    while(1)
    {
	sys->sleep(5);
	if ((n=rfb->ReadExact(c,msg,1))<0) {
	    debug(0,"Lecture msg\n");
	    return;
	}
	case int msg[0] {
	    # le client specifie son format de pixel
	    rfb->SetPixelFormat =>
	    rpf :=array[20] of byte;
	    if ((n=rfb->ReadExact(c,rpf[1:],19))<=0) {
		if (n == 0)
		    sys->fprint(stderr,"client gone\n");
		else
		    sys->fprint(stderr,"erreur reseau %r\n");
		return; 
	    }

	    sys->print("%s\n",rfb->hexstrbuf(rpf));
	    
	    (bpp,depth,bigendian,truecol,rmask,gmask,bmask,rshift,gshift,bshift):=rfb->PixelFormat.liste(rpf[4:20]);
	    debug(0,"Client : "+
		  string bpp+" bpp "+
		  string depth+" depth ");
	    pf.set(pf.get(rpf[4:20]));
	    
	    # Si le client accepte le mode colormap
	    debug(0,pf.sprint());
	    if (!pf.truecolor())
	    {
		debug(0,"on fixe la table des couleurs");
		buf :=array[6] of byte;
		buf[0:]=rfb->CARD(8,rfb->mtSetColourMapEntries);
		buf[2:]=rfb->CARD(16,0);
		buf[4:]=rfb->CARD(16,(1<<bpp));
		if (rfb->Send_Data(c,buf)<0)
		    return;
		for (i:=0; i<(1<<bpp); i++)
		{
		    (r,v,b):=ctxt.display.cmap2rgb(i);
		    buf[0:]=rfb->CARD(16,r);
		    buf[2:]=rfb->CARD(16,v);
		    buf[4:]=rfb->CARD(16,b);
		    if (rfb->Send_Data(c,buf)<0)
			return;
		}
	    }
	    #if (!CorrectPixFormat(rpf[4:20])){
	    #sys->fprint(stderr,"Client has wrong pixel format\n");
	    #	return;
	    #}

	    # le client fixe les entrees de sa palette
	    rfb->FixColourMapEntries =>
		fatal(sys->fprint(stderr,"FixColourMapEntries non implemente"));
	    
	    # Le client donne ses encodages dans l'ordre de preference
	    rfb->SetEncodings =>
	    se := array[4] of byte;
	    if ((n=rfb->Read_Data(c,se[1:]))<0)
		return;
	    
	    if (encodagel.read(c,rfb->INT(se[2:4]))<0)
		return;
	    
	    # Evenement clavier du client
	    rfb->KeyEvent =>
	    kb :=array[8] of byte;
	    if ((n=rfb->ReadExact(c,kb[1:],7))<=0) {
		if (n == 0)
		    sys->fprint(stderr,"client gone\n");
		else
		    sys->fprint(stderr,"erreur reseau %r\n");
		return;
	    }
	    #if (rfb->INT(kb[4:8])== 16rff1b )  
	    #fatal(sys->fprint(stderr,"Touche Escape, fin serveur\n"));
	    touche :=rfb->INT(kb[4:8]);
	    downflag :=rfb->INT(kb[1:2]);
	    		    
	    if (!Cignoreevent) {
		if (touche>32 && touche<127 && downflag)
		    tk->keyboard(ctxt.screen,touche);
		else 
		    sys->fprint(stderr,"touche [%4x],%d non geree\n",touche,downflag);
		#tk->keyboard(ctxt.screen,rfb->INT(kb[4:8]) & 16rff);
		#tk->cmd(ctxt.screen,"update");
	    }
	    # Evenement souris du client
	    rfb->PointerEvent =>
	      pt:=array[6] of byte;
	    if ((n=rfb->ReadExact(c,pt[1:],5))<=0) {
		if (n == 0)
		    sys->fprint(stderr,"client gone\n");
		else
		    sys->fprint(stderr,"erreur reseau %r\n");
		return;
	    }
	    {
		x,y,b : int; s:string;
		x=rfb->INT(pt[2:4]); y=rfb->INT(pt[4:6]); b=int pt[1];
		if (!Cignoreevent) {
		    tk->mouse(ctxt.screen,x,y,b);
		    #tk->cmd(ctxt.screen,"update");
		}

		#sys->print("m%11d %11d %11d ",x,y,b);
		#sys->write(mfd, array of byte s, 37);
                #mchan <-=  (x,y,b);
	    }
	    rfb->mtClientCutText =>
		
	    cct :=array[8] of byte;
	    if ((n=rfb->ReadExact(c,cct[1:],7))<0)
		fatal(sys->fprint(stderr,"Client cut"));
	    
	    ppl :=rfb->INT(cct[4:8]);
	    textcut :=array[ppl] of byte;
	    if ((n=rfb->ReadExact(c,textcut,ppl))<0)
		fatal(sys->fprint(stderr,"Client cut text "));
	    wmlib->snarfput(string textcut);
	    sys->print("Le client a coupe [%s]\n",string textcut);

	    # demande du client de mise a jour du framebuffer
	    rfb->mtFramebufferUpdateRequest=>
	    sur :=  array[10] of byte;
	    if ((n=rfb->ReadExact(c,sur[1:],9))<=0) {
		if (n == 0)
		    sys->fprint(stderr,"client gone\n");
		else
		    sys->fprint(stderr,"erreur reseau %r\n");
		return; 
	    }
	    sys->print("demande %d,%d taille %d,%d mode %d\n",rfb->INT(sur[2:4]),rfb->INT(sur[4:6]), rfb->INT(sur[6:8]),rfb->INT(sur[8:10]),int sur[1]);
	    r := rfb->Rectangle (
				 (rfb->INT(sur[2:4]),
				  rfb->INT(sur[4:6])),
				 (rfb->INT(sur[2:4])+rfb->INT(sur[6:8]),
				  rfb->INT(sur[4:6])+rfb->INT(sur[8:10]))
				 );
	    pf.enc = encodagel;
	    requetes ++;
	    if (requetes<=1) {
		if (int sur[1]==0) { # demande initiale
		    #sys->fprint(stderr,"demande initiale\n");
		    
		    primaryupdate(c, ctxt,r,pf);
		} 
		else
		{ 
		    # update incremental
		#sys->fprint(stderr,"incrementale\n");
		    incrementupdate(c,ctxt,r,pf);
		}
		requetes--;
	    }

	    if (c == nil)
		return;
	    # service non gere
	    * => 
		sys->fprint(stderr,"rfbProcessClientMessage: unknown message type %d\n",int msg[0]);
	    return;
	}
    }
}


EcouteTcp(port : int) : ref sys->Connection
{

	nomcon:=net+"/tcp!*!"+string port;
	(err,tcpcon) := sys->announce(nomcon);
	if (err<0) {
     		sys->print("announce avorte : %s\n", nomcon);
		return nil;
	}
	(err,tcpcon)=sys->listen(tcpcon);
	if (err<0) {
	  sys->print("listen avorte : %s\n", nomcon);
	  return nil;
	}

	tcpcon.dfd= sys->open(tcpcon.dir+"/data", sys->ORDWR);
	if (tcpcon.dfd == nil) {
	  sys->print("Ouverture R/W impossible : %s/data",tcpcon.dir);
	  exit;
	}

	return ref tcpcon;
}


mouse(s: ref Draw->Screen)
{
	n := 0;
	x,y,b : int;
	buf := array[100] of byte;
	for(;;) {
	    #(x,y,b) = <- mchan;
	    #n = sys->read(fd, buf, len buf);
	    #if(n <= 0)
	    #break;

		#if(int buf[0] == 'm' && n == 37) {
		#	x := int(string buf[ 1:13]);
		#	y := int(string buf[12:25]);
		#	b := int(string buf[24:37]);
	    sys->print("%d, %d : %d\n",x,y,b);
	    tk->mouse(s, x, y, b);
	    
		#}
	    #sys->print("%s\n",hexstrbuf(buf));
	}
}

contenu (ctxt : ref Context, r: Draw->Rect) : array of byte
{
  pix:=array[(r.max.x-r.min.x)*(r.max.y-r.min.y)] of byte;
    sys->fprint(stderr,"contenu a lu l'image %d %d \n",(r.max.x-r.min.x),(r.max.y-r.min.y));
    #rect := Draw->Rect ( (0,0), (640,480) );
    ctxt.display.image.readpixels(r,pix);
    
    return pix;
}

primaryupdate(c: ref sys->Connection,ctxt : ref Context,r : Rectangle, pf : ref rfb->PixelFormat)
{
    debug(0,"primary update");
    # entete server update
    su :=array[4] of byte;
    su[0]=byte rfb->mtFramebufferUpdate;
    su[2:]=rfb->CARD(16,1);
    rfb->WriteExact(c,su,4);
		
    # entete (RRE)
    rect :=array[12] of byte;
    # on place les meme dimensions que demandee par le client
    rect[0:]=rfb->CARD(16,r.min.x);
    rect[2:]=rfb->CARD(16,r.min.y);
    rect[4:]=rfb->CARD(16,r.dx());
    rect[6:]=rfb->CARD(16,r.dy());
    rect[8:]=rfb->CARD(32,rfb->EncodingRRE);
    rfb->WriteExact(c,rect,12);
    
    # ecriture rectangle noir
    hdr :=array[4+rfb->INT(pf.PIXEL_FORMAT[0:1])/8] of byte;
    # 0 sous rectangles
    hdr[0:]=rfb->CARD(32,0);
    # couleur 1
    buf :=array[1] of { byte 0};
    cmap2rfbpix(buf,hdr[4:],pf);
    rfb->WriteExact(c,hdr,len hdr);  
}

incrementupdate(c: ref sys->Connection,ctxt : ref Context, r: rfb->Rectangle, pixformat: ref rfb->PixelFormat)
{
    VNCbpp := rfb->INT(pixformat.PIXEL_FORMAT[0:1]);
    debug(0,"incremental update");

    # Y'a t il des fenetres Tk ?
    l := tk->windows(ctxt.screen);
    myrect :=ctxt.screen.image.r;

    li : list of Rect;
    if (l!=nil)
    {
	li = nil;
	for (i:=0; l!=nil; i++) {
	    e :=hd l;
		if (e.image!=nil ) {
		    sys->print("%d %d -> %s\n",i,e.id,printrect(e.image.r));
		    li = e.image.r :: li;
		    #sys->print("TkWinfo %s\n",tk->cmd(e,". winfo"));
		}
	    l=tl l;
	}
    }
    listerectfond := OUTrect(myrect,li);
    listerectwin : list of rfb->Rectangle;
    #while (li != nil) {
    #}

    # on etabli une liste des rectangles des fenetres
    listepave : list of rfb->Pave;
    surfacetot :=0;
    while (li != nil) {
	pav : rfb->Pave;
	pav.r = hd li;
	pav.encoding = rfb->Encodingraw;
	surfacetot+=pav.r.surf();
	if (0) {
	if (pixformat.enc.accepte(rfb->EncodingRRE)) 
	    pav.encoding = rfb->EncodingRRE;
	
	else if (pixformat.enc.accepte(rfb->Encodinghextile)) 
	    pav.encoding = rfb->Encodinghextile;
	else 
	    pav.encoding = rfb->Encodingraw;
    }
	listepave = pav :: listepave;
	li = tl li;
    }
    sys->print("envoie fenetre en liste pave %d\n",len listepave);
    t1 := sys->millisec();
    bigtaille:=SendRectList(c,ctxt.screen,listepave,pixformat);
    t2 := sys->millisec();
    sys->print("S[%d] B%d T%d\n",surfacetot,bigtaille,t2-t1);


    listepave = nil;
    while (listerectfond != nil) {
	pav : rfb->Pave;
	pav.r = hd listerectfond;
	if (pixformat.enc.accepte(rfb->EncodingRRE)) 
	    pav.encoding = rfb->EncodingRRE;
	else
	    pav.encoding = rfb->Encodingraw;
	
	listepave = pav :: listepave;
	listerectfond = tl listerectfond;
    }
    sys->print("envoie fond en liste pave %d\n",len listepave);
    SendRectList(c,ctxt.screen,listepave,pixformat);
    return;
    
    #UpdateFrameBuffer(c,ctxt.screen,r,pixformat);
    
    # Si le client accepte les encodages RRE, coRRE et copyrectangle
    # Decoupage de l'ecran en zones
	
    #sys->print("allocation %d...",r.dx()*r.dy());
    
    #pix:=array[r.dx()*r.dy()] of byte;
    #sys->print("fin\n");
    
    #rect := Draw->Rect ( (0,0), (640,480) );
    #sys->fprint(stderr,"lecture image %d,%d %d %d \n",r.min.x,r.min.y,r.max.x,r.max.y);
    ctxt.display.image.readpixels(r,pix);
    #sys->print("comparaison ...");
    
    rdif :=draw->Rect ((800,600),(0,0));
    rsam :=r;
    compt :=0;
    pt :Draw->Point;
    #point:Point; 
    largeur :=r.max.x-r.min.x;
    # recherche min y
    
    
    for (pt.y=r.min.y; pt.y<r.max.y; pt.y+=8) {
	#sys->sleep(0);
	for (pt.x=r.min.x; pt.x<r.max.x; pt.x+=8) {
	  pos:=(pt.x+pt.y*largeur);
	    if (int pix[pos] != int oldpix[pos]) {
		if (rdif.min.x>pt.x)
		    rdif.min.x=pt.x;
		if (rdif.min.y>pt.y)
		    rdif.min.y=pt.y;
		if (rdif.max.x<pt.x)
		    rdif.max.x=pt.x+8;
		if (rdif.max.y<pt.y)
		    rdif.max.y=pt.y+8;
		
		
	    }
	}
    }
    #rdif=draw->Rect ((100,100),(200,200));
    oldpix[0:]=pix[0:];
    rdif=(rdif.min.div(1),rdif.max.div(1));
    sys->fprint(stderr,"iter %d rectangle modifie %d,%d %d,%d ...",compt,rdif.min.x,rdif.min.y,rdif.max.x,rdif.max.y);
    
    sys->print("fin\n");
    #hdr:=contenu(ctxt, r);
    
    if (rdif.min.x<rdif.max.x) {
	# entete server update
	su :=array[4] of byte;
	su[0]=byte rfb->mtFramebufferUpdate;
	su[2:]=rfb->CARD(16,1);
	rfb->WriteExact(c,su,4);
	
	rdif=rdif.canon();
	# on place les coordonnees du rectangle modifie
	rect := array[12] of byte;
	rect[0:] = rfb->CARDRECT(rdif);
	rect[8:]=rfb->CARD(32,rfb->Encodingraw);
	rfb->WriteExact(c,rect,12);
	
	sys->print("ecriture %d,%d %d,%d\n",rfb->INT(rect[0:2]),rfb->INT(rect[2:4]), rfb->INT(rect[4:6]),rfb->INT(rect[6:8]));
	
	sys->print("Il faut ecrire %d points... ",rdif.dx()*rdif.dy());
	bufsend :=array[rdif.dx()*(ldepth-2)] of byte;
	tmpDEBUG :=rfb->DEBUG;
	rfb->DEBUG=0;
	buf :=array[rdif.dx()*VNCbpp/8] of byte;
	sys->print("buffer d'envoi : %d octets (VNCbpp %d)\n",rdif.dx()*VNCbpp/8,VNCbpp);
	for (pt.y=rdif.min.y; pt.y<rdif.max.y; pt.y++) {
	    
	    cmap2rfbpix(pix[pt.y*r.dx()+rdif.min.x:pt.y*r.dx()+rdif.max.x],buf,pixformat);
	    if (!rfb->WriteExact(c,buf,len buf)) 
		fatal(sys->fprint(stderr,"ecriture donnees\n"));
	    
	}
	rfb->DEBUG=tmpDEBUG;
	sys->print("%d ecrit. fin\n",compt);
    }
    else {  
	# entete server update
	su :=array[4] of byte;
	su[0]=byte rfb->mtFramebufferUpdate;
	su[2:]=rfb->CARD(16,0); # pas de rectangles ! pareils
	rfb->WriteExact(c,su,4);
	sys->print("Pas de mise a jour\n");
    }
}

vncconf(ctxt : ref Draw->Context)
{
    about_cfg := array[] of {
        #"label .b -bitmap @/icons/logon.bit",
	"frame .i",
	"label .i.i1 -bitmap @/lib/vnc.bit", 
	"label .i.i2 -bitmap @/icons/tk/oldinferno.bit",
	"label .i.i3 -bitmap @lib/mime.bit", 
        "label .t -text { VNC v3.3 for Inferno OS\nMarc Hufschmitt, Mime Up8\n}",
	"frame .f",
	"checkbutton .f.acpt -value on -text {Refuser les connections} -command {send c refuse}",
	"checkbutton .f.java -value on -text {Accepter les clients Java} -command {send c okjava}",
	#"checkbutton .f.auto -value 1 -text {No de display automatique} -variable on -command {send c autonb}",

	"checkbutton .f.evnt -text {Ignore les evenements} -command {send c noevent}",
	"radiobutton .f.auth1 -text {Authentification VNC} -command {send c authvnc; .f.pwd.word configure -state normal}",
	"radiobutton .f.auth0 -text {Sans Authentification} -command {send c authnon; .f.pwd.word configure -state disabled}",
	sys->sprint(".f.auth%d select",Cvncauth),
	#"button .f.exit -text {Quitter} -command {send c quitter}",
	"frame .f.pwd",
	"button .f.pwd.valid -text {Sauver} -command {send c fixpwd}",
	"entry .f.pwd.word  -show * -width 12w",
	"pack .f.pwd.word -side left",
	"pack .f.pwd.valid -side right",
	".f.pwd.word insert 0 "+passwd,
	"bind .f.pwd.word <Key-\n> {send c fixpwd}",
	
	"pack .f.acpt -side top",
	"pack .f.java -side top",
	"pack .f.evnt -side top",
	"pack .f.auth1 -side top",
	"pack .f.auth0 -side top",
	"pack .f.pwd -side top",
	#"pack .f.exit -side bottom",
	#"pack .f.auto",
	
	"pack .i.i1 .i.i2 .i.i3 -side left",
	#"pack .i2 -side right",
	"pack .i -side top",
	"pack .t",
	"pack .f -fill both",
	"pack propagate . 0",
	"update",
    };
    c := chan of string;
    wmlib->init();
    tkargs := "";
    #titlectl : chan of string;
    (t, titlectl):= wmlib->titlebar(ctxt.screen, tkargs, "Serveur VNC", wmlib->Appl);
    wmlib->tkcmds(t, about_cfg);
    tk->namechan(t, c, "c");

    if (len passwd == 0)
	notice(ctxt,"Le mot de passe du serveur n'a pas ete fixe");
    
    for(;;) 
	alt {
	    menu := <-titlectl =>
	    if(menu[0] == 'e')
		fatal(sys->print("Fin du serveur VNC\n"));
	    
	    wmlib->titlectl(t, menu);
	    commande :=<-c =>
	    case commande {
		"refuse" => Crefuseconnect =~Crefuseconnect;
		"autonb" => ;
		"noevent" => Cignoreevent=~Cignoreevent;
		"quitter" => fatal(sys->print("Fin du serveur VNC\n"));
		"fixpwd" => 
		if (vncauth->EncryptAndStorePasswd(passwd=tk->cmd(t,".f.pwd.word get"),passwordfile)<0) {
		    notice(ctxt,"Erreur en ecriture de "+passwordfile);
		    sys->fprint(stderr,"%r\n");
		    }
		else
		    notice(ctxt,"Mot de passe enregistre\n");
		"authvnc" => Cvncauth=1;
		"authnon" => Cvncauth=0;
		"displaynb" => Cdisplaynb:=tk->cmd(t,".f.dpnb get");
		* => sys->fprint(stderr,"TK %s unimplemented\n",commande);
	    }
	}
}

OUTrect(ecran : Rect, li : list of Rect) : list of Rect
{
    l : list of Rect;
    l=nil;
    if (li==nil) {
	#sys->print("%s\n",printrect(ecran));
	return ecran :: nil;
    }
    ri :=hd li;
    #sys->print("Il reste %d elements danla liste\n",len li);
    # bande du haut
    if (ri.min.y>ecran.min.y) {
	if (ecran.max.y<ri.min.y) {
	    #sys->print("tout l'ecran\n");
	    return addlists(OUTrect(ecran,tl li),l);
	}
	r1:=ecran;
	r1.max.y=ri.min.y;
	#sys->print("on a une bande en haut %s\n",printrect(r1));
	l=addlists(OUTrect(r1,tl li),l);
	ecran.min.y=r1.max.y;
    }
    #bande bas
    if (ri.max.y<ecran.max.y) {
	if (ecran.min.y>ri.max.y) {
	    #sys->print("tout l'ecran\n");
	    return addlists(OUTrect(ecran,tl li),l);
	}
	r1:=ecran;
	r1.min.y=ri.max.y;
	#sys->print("on a une bande en bas %s\n",printrect(r1));
	l=addlists(OUTrect(r1,tl li),l);
	ecran.max.y=r1.min.y;
    }
    #bande gauche
    if (ri.min.x>ecran.min.x) {
	if (ecran.max.x<ri.min.x) {
	    #sys->print("tout l'ecran\n");
	    return addlists(OUTrect(ecran,tl li),l);
	}
	r1:=ecran;
	r1.max.x=ri.min.x;
	#sys->print("on a une bande en haut %s\n",printrect(r1));
	l=addlists(OUTrect(r1,tl li),l);
	ecran.min.x=r1.max.x;
    }
    #bande de droite
    if (ri.max.x<ecran.max.x) {
	if (ecran.min.x>ri.max.x) {
	    #sys->print("tout l'ecran\n");
	    return addlists(OUTrect(ecran,tl li),l);
	}
	r1:=ecran;
	r1.min.x=ri.max.x;
	#sys->print("on a une bande en bas %s\n",printrect(r1));
	l=addlists(OUTrect(r1,tl li),l);
	ecran.max.x=r1.min.x;
    }
    return l;
}

INrect(ecran : Rect, li : list of Tk->Toplevel) : list of Rectangle
{
    if (len li<1)
	return nil;
    tabr :=array[len li] of Tk->Toplevel;
    
    i := 0;
    while (li!=nil) {
	tabr[i]=hd li;
	i++;
	li = tl li;
    }
    
    for (i = 0; i<len tabr - 1 ; i++) {
	for (j := 1; j < len tabr ; j++) {
	    #if (tabr[i].r
	}
    }
    if (li == nil) 
	return nil;

    #ri := hd li;
    #if (ri.min.x<ecran.min.x)	ri.min.x=ecran.min.x;
    #if (ri.min.y<ecran.min.y)	ri.min.y=ecran.min.y;
    #if (ri.max.x>ecran.max.y)	ri.max.x=ecran.max.x;
    #if (ri.max.y>ecran.max.y)	ri.max.y=ecran.max.y;

    
    
#	    if (ri.max.y)
    return nil;
}

addlists(l1,l2 : list of Rect) : list of Rect
{
    l : list of Rect;
    l=l1;
    #sys->print("Ajout de %d a %d\n",len l1,len l2);
    while (l2!=nil) {
	l= hd l2 :: l;
	l2 = tl l2;
    }
    #sys->print("cela donne %d\n", len l);
    return l;
}

readdisplayproperties(ctxt : ref Draw->Context) : (Draw->Rect,int)
{
    ima :=ctxt.display.image;
    return (ima.r,ima.ldepth);

    id :=ctxt.screen.id;
    sys->print("Screen ID : %d\n",ctxt.screen.id);
    if((fd:=sys->open("/dev/draw/"+string id+"/ctl",sys->OREAD))==nil)
	fatal(sys->fprint(stderr,"Impossible d'ouvrir le display %d:%r",id));
    buf :=array[12*7+1] of byte;
    if (sys->read(fd,buf,len buf)<len buf)
	fatal(sys->fprint(stderr,"Impossible de lire %d/ctl\n",id));
    ldepth :=int string buf[12*2:12*3];
    srect : Draw->Rect;
    
    srect.min.x=int string buf[12*3:12*4];
    srect.min.y=int string buf[12*4:12*5];
    srect.max.x=int string buf[12*5:12*6];
    srect.max.y=int string buf[12*6:12*7];
    sys->print("%d %d %d %d %d\n",srect.min.x,srect.min.y,srect.max.x,srect.max.y,ldepth);
    return (srect,ldepth);
}


equarray( a, b : array of byte) : int
{
    r : int;
    if (len a == len b) { 
	for (i:= 0; i < len a; i++)
	    if (a[i]!=b[i])
		return 1==0;
	return 1==1;
    }
    return 1==0;;
}


cmap2rfbpix(buf, pix : array of byte, pixf : ref PixelFormat)
{
    sp :=0;
    dp :=0;
    l := len buf;
    r,v,b : int;
    p : int;
    (bpp,nil,bigendian,nil,rm,vm,bm,rs,vs,bs):=pixf.liste(pixf.PIXEL_FORMAT);
    if (pix==nil)
	pix = array[(len buf)*(bpp/8)] of byte;
    # En mode colormap pas de conversion
    if (!pixf.truecolor()) {
	if (bpp==8)
	    pix[0:]=buf[0:];
	else
	    fatal(sys->fprint(stderr,"mode colormap > 8 bpp non gere\n"));
	pix[0:]=buf[0:];
    }
    # En mode truecolor
    else {
	
	if (bpp==8) {
	    #debug(0,"conversion BGR233");
	    for(i:=0; i<len buf; i++) {
		(r, v, b) := Infernocolormap[int buf[i]];
		pix[i]=byte ((((r>>5) & (7<<0)) | ((v >> 2) & (7<<3)) | ((b>>0) & (3<<6))) & 255);
		
	    }
	    
	}
	else if (bpp==16)
	{
	    if (bigendian)
		for(i:=0; i<len buf; i++) {
		    (r, v, b) := Infernocolormap[int buf[i]];
		    pix[i*2:]=rfb->CARD(16,((((r) & (63<<0)) | ((v << 2) & (31<<6)) | ((b<<8) & (31<<5))) & 65535));
		}
	    else {
	      tempo:=array[2] of byte;
		for(i:=0; i<len buf; i++) {
		    (r, v, b) := Infernocolormap[int buf[i]];
		    tempo[0:]=rfb->CARD(16,((((r) & (63<<0)) | ((v << 2) & (31<<6)) | ((b<<8) & (31<<5))) & 65535));
		    pix[i*2]=tempo[1];
		    pix[i*2+1]=tempo[0];
		    
		}
	    }
	}
	else
	    fatal(sys->fprint(stderr,"mode non gere\n"));
    }
    
}


UpdateFrameBuffer(c : ref Sys->Connection, s : ref Draw->Screen, myrect: Rectangle ,pixformat : ref rfb->PixelFormat)
{
    VNCbpp :=rfb->INT(pixformat.PIXEL_FORMAT[0:1]);
    pave : rfb->Pave;
    pave.encoding=rfb->EncodingRRE;
    pave.r = ((00,00),(800,600));
    l : list of rfb->Pave;
    l = pave :: nil;
    SendRectList(c,s,l,pixformat);
    #
    return;
}

# envoi d'une liste de rectangles et stats
SendRectList(c : ref Sys->Connection, s : ref Draw->Screen, lir : list of rfb->Pave, pf : ref PixelFormat) : int
{
    lt := lir;
    ln :=0;
    if (len lir) {
	fbu := array[4] of byte;
	fbu[0:] = rfb->CARD(8,rfb->mtFramebufferUpdate);
	fbu[2:] = rfb->CARD(16,len lir);
	if ((ln+=rfb->Send_Data(c,fbu))<0) {
		c=nil;
		debug(1,"Erreur ecriture : envoi entete rectangle en Raw");
		return 0;
	    }
    }
    else
	return 0;
    
    fbur := array[12] of byte;
    while (lt != nil) {
	rect := hd lt;
	if (rect.r.surf()!=0) {
	    fbur[0:] = rfb->CARDRECT(rect.r);
	    if (rect.r.dx()<256 && rect.r.dy()<256 && rect.encoding==rfb->EncodingRRE)
		rect.encoding=rfb->EncodingCoRRE;
	    fbur[8:] = rfb->CARD(32,rect.encoding);
	    if ((ln+=rfb->Send_Data(c,fbur))<0) {
		c=nil;
		debug(1,"Erreur ecriture : envoi entete rectangle en Raw");
		return 0;
	    }
	    case rect.encoding {
		rfb->Encodingraw =>
		ln += SendRectEncodingRaw(c,s,rect.r,pf);
		rfb->Encodinghextile =>
		ln += SendRectEncodingHextile(c,s,rect.r,pf);
		rfb->EncodingRRE or rfb->EncodingCoRRE=>
		ln += SendRectEncodingRREcoRRE(c,s,rect.r,pf);	
		* =>
		debug(0,"encoding unknow pour l'envoi de " +printrect(rect.r));
	    }
	    if (ln<=0)
		return 0; 
	}
	VNCstat[rect.encoding]+=ln;
	lt = tl lt;
    }
    return ln;
}


# Envoie un rectangle au format raw et retourne le nombre d'octets emis
SendRectEncodingRaw(c : ref Sys->Connection, s : ref Draw->Screen, r : Rectangle, pf : ref rfb->PixelFormat) : int
{
    ln :=0;
    bpp := int pf.PIXEL_FORMAT[0];

    bufout := array[bpp/8*r.surf()] of byte;
    bufscr := array[r.surf()] of byte;

    s.image.readpixels(r,bufscr);
    cmap2rfbpix(bufscr,bufout,pf);

    if ((ln+=rfb->Send_Data(c,bufout))<0) {
	c=nil;
	debug(1,"Erreur ecriture : envoi rectangle en Raw");
    }
    return ln;
}
    
