#PROJECT : VNC 3.3 client and server for Inferno
#AUTHOR :  Marc Hufschmitt, marcas1@mime.univ-paris8.fr

# RFB protocol : RRE and coRRE encodings

SendRectEncodingRREcoRRE(c : ref Sys->Connection, s : ref Draw->Screen, r : rfb->Rectangle, pf : ref PixelFormat) : int
{
    re : rfb->Rectangle;
    lp : list of rfb->Pave;
    re=r;
    scr := array[re.surf()] of byte;
    s.image.readpixels(r,scr);

    bpp := rfb->INT(pf.PIXEL_FORMAT[0:1]);
    RRE, coRRE : con iota;
    mode : int;
    if ((re.dx()<256) && (re.dy()<256))
	mode = coRRE;
    else
	mode = RRE;

    w := re.dx();
    h := re.dy();
    hx, hy, vx, vy : int;
    vx = hx =0;
    taille :=0;

    # Methode cavaliere pour trouver la couleur principale de fond
    thestep := 4;
    potbg := array[thestep*thestep] of { * => byte 0 };
    potfreq := array[thestep*thestep] of { * => 0 };
    while ((thestep < 16) && (thestep<r.dy()) && (thestep<r.dx())) {

        #sys->print("%d\n",thestep);
        for (y := r.dy()/thestep/2; y < r.dy(); y+=r.dy()/thestep) {
            
            for (x := r.dx()/thestep/2; x < r.dx(); x+=r.dx()/thestep) {
                
		for (i:=0; (i < len potbg) ; i++) {
		    
		    if (potfreq[i]==0) {
			potfreq[i]++; 
			potbg[i]=scr[x+r.dx()*y];
			break;
		    }
		    else if (potbg[i]==scr[x+r.dx()*y]) {
			potfreq[i]++;
			break;
		    }
		}
                #sys->print("x:%d y:%d %d\n",x,y,int bufscr[x+r.dx()*y]);
                
            }
        }
        thestep+=1;
    }
    
    bg : byte;
    fq := 0;
    for (i := 0 ; i< len potbg; i++) {
	#sys->print("potbg %d => coul %d x %d\n",i,int potbg[i],potfreq[i]);
	if (fq < potfreq[i]) {
	    fq = potfreq[i];
	    bg = potbg[i];
	}
    }
    #sys->print("potbg %d\n",int bg);

    
    # parcours des lignes
    for (y := 0 ; y < h ; y++) {
	#line = data+(y*w); 
        
	#parcours des pixels de la ligne
	for (x := 0; x < w ; x++) {
            
	    # Si le point est different du fond
	    if (scr[y*w+x] != bg) {
                # la couleur courante est celle du premier point
		cl := scr[y*w+x];
		# rectangle horizontal de hauteur ....
                hy := y;
		# rectangle horizontal a calculer
                hyflag := 1;
		
		# Pour chacune des lignes partant de la ligne y
                for (j := y; j < h; j++) {
                    #seg = data+(j*w);
		    
		    # si le point change de couleur ici on arrete
                    if (scr[j*w+x] != cl) {break;}

                    # i parcourt la ligne
		    i := x;
                    # tant que la couleur est la meme sur la ligne on avance
		    while ((i < w) && (scr[j*w+i] == cl)) 
			i++;

		    # si sur la premiere ligne la largeur 
		    # des deux rectangles potentiel s'arrete en i
                    if (j == y) vx = hx = i;
                    
		    # si le point de droite est plus petit que
		    # la fin du rectangle vertical on ajuste sa largeur max
		    if (i < vx) vx = i;                                       
                    
		    # si mode horizontal && i plus grand 
		    # que la fin du rectangle horizontal
		    if ((hyflag > 0) && (i >= hx)) {                          
                        # notre rectangle horizontal fini avant i
			hy += 1;                                              
                    } else {
			# sinon fin du rectangle horizontal
			hyflag = 0;
                    }                                                         
                }
                vy = j-1;
		# on choisi le plus grand des deux rectangles
		# rectangle horizontal (x,y,hx,hy) et        
		# rectangle vertical (x,y,vx,vy)
                 
		p1 : rfb->Pave;
		p2 : rfb->Pave;
		p1.r.min = (x,y);
		p2.r.min = (x,y);
		p1.r.max = (hx,hy);
		p2.r.max = (vx,vy);

                if ((p1.r.surf()) < (p2.r.surf())) {
		    p1.r = p2.r;
		}
		
		taille+=4+bpp/8;
		if (mode==RRE) 
		    taille+=4;
		
		p1.couleur = cl;		
		
		#  Abandon si la taille depasse l'ecodage Raw
		if ((taille+4+bpp/8) > (w*h*bpp/8)) {
		    #sys->print("Depasse raw\n");
		    return -1;
		}
		#return (taille,nil);

		lp = p1 :: lp;


		# Le rectangle est fait
		for (j = p1.r.min.y ; j < p1.r.max.y; j++) {
		    for (i := p1.r.min.x; i < p1.r.max.x; i++) {	  
			# On le marque a la couleur du fond
                        scr[j*w+i] = bg;
		    }
		}
	    }
	}
    }  
    #sys->print("%x rect RRE\n",len lp);
    RREcoRREheader := array[4+bpp/8] of byte;
    RREcoRREheader[0:]=rfb->CARD(32,len lp);
    color :=array[1] of { * => bg};
    cmap2rfbpix(color,RREcoRREheader[4:],pf);
    if (rfb->Send_Data(c,RREcoRREheader)<0)
	return 0;
    RREbuf := array[8+bpp/8] of byte;
    coRREbuf := array[4+bpp/8] of byte;

    limb : list of rfb->Pave;
    LIMITRAW :=(12+2*bpp/8);
    RATIO :=  ((re.surf()-1)/4)/5;
    while (lp != nil) {
	p := hd lp;
	if (p.r.surf() < LIMITRAW) {
	    rt : rfb->Pave;
	    rt.r = p.r;
	    rt.encoding = rt.r.surf();
	    limbt : list of rfb->Pave;
	    trouve := 0;
	    while (limb != nil) {
		rte := hd limb;
		#rd := Rectangle (((rt.max.x+rt.min.x)/2,(rt.max.y+rt.min.y)/2),		  ((rte.min.x+rte.max.x)/2,(rte.min.y+rte.max.y)/2));
		#if (((rd.dx() <= re.dx()/8) && (rd.dy() < re.dy()/8) && ) || !((rte.min.x >= rt.max.x) || (rte.max.x <= rt.min.x) || (rte.min.y >= rt.max.y) || (rte.max.y <= rt.min.y))) {
		rto := rte.r.ORrect(rt.r);

		max := 8.0;
		a := max / (4.0 - real re.surf());
		b := max * ( 1.0 - (4.0 / ( 4.0 - real re.surf())));
		RATIO := ((real rto.surf()) * a + b);
		#sys->print("RATIO %f\n",RATIO);
		if (rto.surf()/((rt.encoding+rte.encoding)) <= 1+int RATIO) {
		    trouve = 1;
		    rt.r = rto;
		    rt.encoding += rte.encoding;
		}
		else {
		    limbt = rte :: limbt;
		}
		limb = tl limb;
	    }
	    limb = rt :: limbt;
	    limbt = nil;
	}
	sys->sleep(0);
	if (mode==RRE)	{
	    color :=array[1] of { * => p.couleur};
	    cmap2rfbpix(color,RREbuf[0:],pf);
	    RREbuf[bpp/8:]=CARDRECT(p.r);
	    rfb->Send_Data(c,RREbuf);
	}
	else {
	    color :=array[1] of { * => p.couleur};
	    cmap2rfbpix(color,RREbuf[0:],pf);
	    coRREbuf[bpp/8+0:]=CARD(8,p.r.min.x);
	    coRREbuf[bpp/8+1:]=CARD(8,p.r.min.y);
	    coRREbuf[bpp/8+2:]=CARD(8,p.r.dx());
	    coRREbuf[bpp/8+3:]=CARD(8,p.r.dy());
	    rfb->Send_Data(c,coRREbuf);
	}
	lp = tl lp;
    }

    
    sys->print("%d rectangles idiots\n",len limb);

    buf :=array[28+bpp/4]of{byte 0,byte 0,
			    byte 0,byte 1,
			    byte 0,byte 0,byte 0,byte 0,byte 0,byte 0,byte 0,byte 0,
			    byte 0,byte 0,byte 0,byte 2,
			    byte 0,byte 0,byte 0,byte 1};
    

    
    
    limbf := limb;
    #sys->print("Rectangle %d %s\n", len limbf,printrect(rt));
    sys->print("J'ai reduit en %d regions RATIO %d\n",len limbf,RATIO);
    if (0) {
    while (limbf !=nil) {

	p := hd limbf;
	buf[4:] = rfb->CARDRECT(p.r);
	buf[20+bpp/4:] = rfb->CARDRECT(((0,0),(0,0)));
	buf[20:]=CARD(bpp,2r1001001*(len limbf));
	buf[20+bpp/8:]=CARD(bpp,2r1001001*(len limbf));
	rfb->Send_Data(c,buf);
	limbf = tl limbf;
    }

}    
	
    limb = nil;
    sys->print("Je viens d'envoyer %d octets\n",taille);
    return taille;
    
} 
	
